"\n"
"/*\n"
"UTF-8 Table\n"
"8421 8421\n"
"110x xxxx   2 bytes    mask= e0  result= c0   min= 80       vmask= 1f\n"
"1110 xxxx   3 bytes    mask= f0  result= e0   min= 800      vmask= 0f\n"
"1111 0xxx   4 bytes    mask= f8  result= f0   min= 10000    vmask= 07\n"
"1111 10xx   5 bytes    mask= fc  result= f8   min= 200000   vmask= 03\n"
"1111 110x   6 bytes    mask= fe  result= fc   min= 4000000  vmask= 01\n"
"\n"
"10xx xxxx   cont. byte mask= c0  result= 80   vmask= 3f\n"
"*/\n"
"\n"
"UTF8_DECODER_SCOPE\n"
"int utf8_decode_string\n"
"  (uint8_t *input, size_t ilen, uint32_t *output, size_t *olen)\n"
"{\n"
"   uint8_t *end,*start;\n"
"   static const uint32_t bit31= (1<<31);\n"
"   size_t L;\n"
"   int have_errors;\n"
"   int i, contb;\n"
"   uint8_t C;\n"
"   uint32_t outc; uint32_t min;\n"
"\n"
"   end= input+ilen;\n"
"   L= 0;\n"
"   have_errors= 0;\n"
"\n"
"   if (ilen==0) goto done;\n"
"\n"
"again:\n"
"   C= input[0];\n"
"   if ( (C&0x80) ==0)    { outc= C; input++; goto out; }\n"
"   if ( (C&0xe0) ==0xc0) goto seq2; \n"
"   if ( (C&0xf0) ==0xe0) goto seq3;\n"
"   if ( (C&0xf8) ==0xf0) goto seq4;\n"
"\n"
"   // Here, we don\047t care about the seq5 and seq6 stuff.\n"
"   // they are invalid anyway, either overlong or greater\n"
"   // then the unicode limit. We just treat them as unrecognized\n"
"   // bytes and output them.\n"
"invalid_byte:\n"
"   outc= input[0] | bit31;\n"
"   input++;\n"
"   have_errors= 1;\n"
"   goto out;\n"
"\n"
"seq2: outc= C & 0x1f;  min=    0x80; contb= 1; goto do_cont;\n"
"seq3: outc= C & 0x0f;  min=   0x800; contb= 2; goto do_cont;\n"
"seq4: outc= C & 0x07;  min= 0x10000; contb= 3; goto do_cont;\n"
"\n"
"do_cont:\n"
"   start= input;\n"
"   input++;\n"
"   for(i=0;i<contb;i++)\n"
"   {\n"
"     if ((input==end) || ( (input[0]&0xc0) !=0x80)) goto reject;\n"
"     outc= (outc << 6) | (input[0]&0x3f);\n"
"     input++;\n"
"   }\n"
"\n"
"   if (outc<min || outc>0x10ffff) goto reject; \n"
"   if (outc>=0xd800 && outc<=0xdfff) goto reject;\n"
"   if (outc==0xffff || outc==0xfffe) goto reject;\n"
"\n"
"out:\n"
"   output[L++]= outc;\n"
"   if (input<end) goto again;\n"
"done:\n"
"   *olen= L;\n"
"   return have_errors;\n"
"reject:\n"
"   input= start;\n"
"   goto invalid_byte; \n"
"}\n"
"\n"

