
void RENDER
        (uint32_t *str, size_t L, 
        int *RW, int *RH, int *RA,
        unsigned char **Rdata)
{
  static const uint8_t font_data[]= {
@FONTDATA
  };
  static const struct {
    uint32_t ds;
    uint16_t width;
  } glinfo[]= {
@GLMAP
  };
  // static const int nmap= sizeof(glmap)/sizeof(glmap[0]);
  int i,j,k,e,x,y,sX,eX;
  int W, X, *Xpos;
  char buf[20];
  int *map, *gl;
  int ngl;
  unsigned int C;
  int glyph_width;
  const unsigned char *glyph_data;
  unsigned char *data;

  map= alloca(L*sizeof(int));

  e= 0;
  ngl= 0;
  for(i=0;i<L;i++)
  {
    C= str[i];
    
    if (C&(1<<31)) { ngl+=2; e= 1; continue; }
    map[i]= HASH(C);
    if (map[i]!=SENTINEL) { ngl++; continue; }
    sprintf(buf,"%x",C); ngl+= strlen(buf); e= 1;
  }

  if (e) goto fix_encoding_errors;
  else gl= map;

encoding_errors_fixed:

  W= 0;
  for(i=0;i<ngl;i++) W+= glinfo[gl[i]].width;

  if (Rdata) data= malloc(W*FONT_HEIGHT);
  X= 0;
  if (e && Rdata) Xpos= alloca(sizeof(int)*(ngl+1));
  for(i=0;i<ngl;i++)
  {
    if (e && Rdata) Xpos[i]= X;
    glyph_width= glinfo[gl[i]].width;
    if (Rdata) {
      glyph_data= font_data + glinfo[gl[i]].ds;
      for(y=0;y<FONT_HEIGHT;y++)
         for(x=0;x<glyph_width;x++)
            data[y*W+X+x]= glyph_data[y*glyph_width+x];
    }
    X+= glyph_width;
  }
  if (e && Rdata) Xpos[i]= X;
  if (RW) *RW= W;
  if (RA) *RA= FONT_ASCENT;
  if (RH) *RH= FONT_HEIGHT;
  if (Rdata) *Rdata= data;

  if (!e || !Rdata) return ;

  j= 0;
  for(i=0;i<L;i++)
  {
    if (str[i]&(1<<31))
    {
      sX= Xpos[j]; eX= Xpos[j+2];
      for(x=sX;x<eX;x++)
        for(y=0;y<FONT_HEIGHT;y++)
          data[y*W + x] ^= 0xff;
      j+= 2;
      continue;
    }
    if (map[i]==SENTINEL)
    {
      sprintf(buf,"%x",str[i]);
      sX= Xpos[j]; eX= Xpos[j+strlen(buf)];
      for(x=sX;x<eX;x++) {
        data[ 0*W + x]= 0xff;
        data[ (FONT_HEIGHT-1)*W + x]= 0xff;
      }
      for(y=0;y<FONT_HEIGHT;y++)
      {
        data[y*W+sX] = 0xff;
        data[y*W+eX-1] = 0xff;
      }
      j+= strlen(buf);
      continue;
    }
    j++;
  }
  return ;


fix_encoding_errors:
  j= 0;
  gl= alloca(sizeof(int)*ngl);
  for(i=0;i<L;i++)
  {
    if (str[i]&(1<<31))
    {
      sprintf(buf,"%02x", str[i]&0xff);
      for(k=0;buf[k];k++)
         gl[j++]= HASH(buf[k]);
      continue;
    }
    if (map[i]==SENTINEL)
    {
      sprintf(buf,"%x", str[i]);
      for(k=0;buf[k];k++)
         gl[j++]= HASH(buf[k]);
      continue;
    }
    gl[j++]= map[i];
  }
  goto encoding_errors_fixed;
}
